#! /usr/bin/Rscript --vanilla
### Input: 1) IntRegions(markers)' genes(semi-colon seperated) (1-column; each row represents one IntRegion); 2) genes2fun ; 3) MEAGA result ; 4) n , where NumIntFunGenes-n<=NumIntRegions

### Final output file: MEAGA result (only remain those functions satisfy NumIntFunGenes-n<=NumIntRegions) + column indicating # of loci the NumIntRegions are from


Args <- commandArgs(TRUE)
if (length(Args)!=5){
        print("Usage: i) IntRegionsGenes ; ii) genes2fun ; iii) MEAGA result ; iv) n ; v) output")
        quit()
}

intregiongenes <- list()
intgenes <- c()

tempresult <- as.matrix(read.table(Args[1],colClasses="character",header=F))
for (i in 1:dim(tempresult)[1]){
	tempintregiongenes <- strsplit(tempresult[i,],split=";")[[1]]
	### for indepdnent loci occupying different rows in the IntRegionGenes files, there maybe same gene sets, the genes present in multiple rows only need to present once
	if (i>1){
		for (j in 1:(i-1)){
			tempintregiongenes <- tempintregiongenes[match(tempintregiongenes,intregiongenes[[j]],nomatch=0)==0]
		}
	}
	intregiongenes[[i]] <- tempintregiongenes
	intgenes <- c(intgenes,intregiongenes[[i]])
}

intgenes <- unique(intgenes)
gene2fun <- as.matrix(read.table(Args[2],colClasses="character",sep="\t",header=F))

funichSPresult <- as.matrix(read.table(Args[3],colClasses="character",sep="\t",header=T))
funichSPresult <- cbind(funichSPresult,matrix(numeric(),dim(funichSPresult)[1],2))
colnames(funichSPresult)[(dim(funichSPresult)[2]-1):dim(funichSPresult)[2]] <- c("NumIntRegions","IntFunGenes")

for (i in 1:dim(funichSPresult)[1]){
	tempfun <- funichSPresult[i,1]
	tempfungenes <- gene2fun[gene2fun[,2]==tempfun,1]
	tempintfungenes <- unique(intersect(tempfungenes,intgenes))
	numcount=0
	for (j in 1:length(intregiongenes)){
		if (sum(match(tempfungenes,intregiongenes[[j]],nomatch=0)!=0)>0){
			numcount=numcount+1
		}
	}
	funichSPresult[i,(dim(funichSPresult)[2])-1] <- numcount
	funichSPresult[i,dim(funichSPresult)[2]] <- paste(tempintfungenes,collapse=";")
}

result <- funichSPresult[(as.numeric(funichSPresult[,3])-as.numeric(Args[4]))<=as.numeric(funichSPresult[,(dim(funichSPresult)[2]-1)]),]

write.table(result,file=Args[5],col.names=T,sep="\t",row.names=F,quote=F)






